unit Umain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Tabs, Menus, Buttons,
  ClipBrd, Printers, ShellAPI, About, UImageo, UOptions, Utils, Omemo;

type
  TForm1 = class(TForm)
    (* menu principal *)
    MainMenu1: TMainMenu;
    (* menu fichier *)
    Fichier1: TMenuItem;
    Nouveau1: TMenuItem;    (* nouveau fichier *)
    Ouvrir1: TMenuItem;     (* ouvrir fichier *)
    N4: TMenuItem;          (* sparation *)
    Sauver1: TMenuItem;     (* sauver *)
    Sauversous1: TMenuItem; (* sauver sous *)
    N3: TMenuItem;          (* sparation *)
    Fermer1: TMenuItem;     (* fermer *)
    N2: TMenuItem;          (* sparation *)
    Quitter1: TMenuItem;    (* quitter *)
    (* menu Edition *)
    Edition1: TMenuItem;
    Copier1: TMenuItem;     (* copier texte *)
    Couper1: TMenuItem;     (* couper texte *)
    Coller1: TMenuItem;     (* coller texte *)
    N9: TMenuItem;          (* sparation *)
    Options1: TMenuItem;    (* dialogue options *)
    (* menu Dessin *)
    Dessin1: TMenuItem;
    Dessiner1: TMenuItem;   (* redessiner la figure *)
    Sauversous2: TMenuItem; (* sauver figure dans *.fig *)
    Zoom1: TMenuItem;       (* zoom + *)
    Zoom2: TMenuItem;       (* zoom - *)
    N6: TMenuItem;          (* sparation *)
    SauverBMP1: TMenuItem;  (* sauver image BMP *)
    CopierBMP1: TMenuItem;  (* copier image dans Presse-Papiers *)
    N7: TMenuItem;          (* sparation *)
    Imprimer1: TMenuItem;   (* imprimer image *)
    (* menu Aide *)
    Aide1: TMenuItem;
    Indexdelaide1: TMenuItem;   (* index de l'aide *)
    AideImageo: TMenuItem;      (* langage imageo *)
    Aidesurunmotcl1: TMenuItem; (* aide sur mot dit *)
    N5: TMenuItem;              (* sparation *)
    Apropos1: TMenuItem;        (* a propos ... *)
    (* menu contextuel des mmos *)
    MemoPopupMenu: TPopupMenu;
    Sauver2: TMenuItem;         (* sauver texte *)
    Redessiner1: TMenuItem;     (* relier texte et dessiner *)
    Fermer2: TMenuItem;         (* fermer mmo *)
    (* menu contextuel dessin *)
    FigPopupMenu: TPopupMenu;
    Dessiner2: TMenuItem;   (* redessiner *)
    Zoom3: TMenuItem;       (* zoom + *)
    Zoom4: TMenuItem;       (* zoom - *)
    (* barre de boutons *)
    PanelBoutons: TPanel;
    SpeedButton1: TSpeedButton; (* Nouveau *)
    SpeedButton2: TSpeedButton; (* Ouvrir fichier *)
    SpeedButton3: TSpeedButton; (* Sauver fichier *)
    SpeedButton4: TSpeedButton; (* Fermer fichier *)
    SpeedButton5: TSpeedButton; (* Dessiner figure *)
    SpeedButton6: TSpeedButton; (* Aide Wimageo *)
    SpeedButton7: TSpeedButton; (* A propos... *)
    SpeedButton8: TSpeedButton; (* Quitter *)
    (* objets *)
    Notebook1: TNotebook;  (* multi-page d'dition *)
    TabSet1: TTabSet;      (* onglets *)
    PaintBox1: TPaintBox;  (* zone de dessin *)
    SplitPanel: TPanel;    (* barre de sparation *)
    (* botes de dialogue *)
    OpenDialog1: TOpenDialog;    (* ouverture d'un fichier *)
    SaveDialog1: TSaveDialog;    (* enregistrement d'un fichier *)
    PrintDialog1: TPrintDialog;
    Voirsource1: TMenuItem;
    N1: TMenuItem;  (* impression *)
    (* mthodes associes par Delphi *)
    procedure FormCreate(Sender: TObject);
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure Nouveau1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Fermer1Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure Sauversous1Click(Sender: TObject);
    procedure Sauver1Click(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure Couper1Click(Sender: TObject);
    procedure Coller1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Notebook1PageChanged(Sender: TObject);
    procedure SauverBMP1Click(Sender: TObject);
    procedure Dessiner1Click(Sender: TObject);
    procedure CopierBMP1Click(Sender: TObject);
    procedure Imprimer1Click(Sender: TObject);
    procedure Indexdelaide1Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure Sauversous2Click(Sender: TObject);
    procedure AideImageoClick(Sender: TObject);
    procedure Zoom1Click(Sender: TObject);
    procedure Zoom2Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure Aidesurunmotcl1Click(Sender: TObject);
    procedure SplitPanelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SplitPanelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SplitPanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure Voirsource1Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
    MonPoint : String[20];
    Splitting : Boolean;
    CurSplit : Integer;
    function NumPageCourante:Integer;
    function FaireMemo(NomFichier:String; page:TPage):Boolean;
    function PageCourante:TPage;
    function MemoCourant:TMemoFig;
    function NomFichierCourant:String;
    procedure SaveMemo(NomFichier:String);
    procedure SetSize;
    procedure DessineParBitmap;
    procedure OuvreFichier(Nom:String; ro:Boolean);
    (* messages Windows *)
    procedure WMERASEBKGND(var Msg:TMessage); message WM_ERASEBKGND;
    procedure WMDROPFILES(var Msg : TMEssage); message wm_dropfiles;
  end;

var
 Form1: TForm1;   { fentre principale }

implementation

{$R *.DFM}


(************************************************************************)
(*********************** Evnements Delphi ******************************)
(************************************************************************)

(************************************************************************)
(********************* Ouverture et fermeture ***************************)
(************************************************************************)

procedure TForm1.FormCreate(Sender: TObject);
(* cration de la fentre *)
var page : TPage;
    S : String;
    memo : TMemo;
    i,lmm,lpix : Integer;
begin
 (* lecture fichier ini *)
 ReadIniFile;
 (* initialisations des champs *)
 CurSplit:=50;
 MonPoint:='';
 Splitting:=false;
 {lmm:=GetDeviceCaps(canvas.handle,HorzSize);
 lpix:=GetDeviceCaps(canvas.handle,HorzRes);
 Echelle(hFigure,ImpUnit*lpix/lmm);}
 (* gestion multi-page *)
 TabSet1.Tabs.Add(NomNouvellePage);
 Notebook1.Pages[0]:='';
 Notebook1.PageIndex:=0;
 Tabset1.TabIndex:=0;
 Page:=TPage(Notebook1.Pages.Objects[NumPageCourante]);
 (* lecture des paramtres *)
 if paramcount=0 then
  FaireMemo('',page)
 else
  begin
   S:=paramstr(1);
   if FaireMemo(S,page) then
    begin
     notebook1.Pages[0]:=S;
     tabset1.Tabs[0]:=OnlyFileName(S);
     CurSplit:=0;
    end;
  end;
 (* Drag and drop fichiers *)
  DragAcceptFiles(Handle,True);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 with IniRec do
  begin
   top:=Haut; left:=Gauche; height:=Hauteur; width:=Largeur;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
(* fermeture de la fentre *)
var i:Integer;
    memo:TMemo;
    page:TPage;
    tampon:array[0..255] of Char;
begin
 (* fichier ini mis  jour *)
 { inirec }
 with Inirec do
  begin
   Haut:=Top; Gauche:=Left; Largeur:=Width; Hauteur:=Height;
  end;
 WriteIniFile;
 (* demander les sauvegardes ncessaires *)
 if NoteBook1.Pages.Count<1 then exit;
 for i:=0 to NoteBook1.Pages.Count-1 do
  begin
   page:=TPage(NoteBook1.Pages.Objects[i]);
   memo:=TMemo(page.Controls[0]);
   if memo.Modified then
    begin
     if Application.Messagebox(StrPcopy(tampon,'Faut-il sauver '+tabset1.Tabs[i]+' ?'),
        'Confimer',Mb_YesNo)=id_Yes then
      begin
       Notebook1.PageIndex:=i;
       TabSet1.TabIndex:=i;
       Sauver1Click(nil);
      end;
    end;
  end;
 (* fermeture du fichier d'aide s'il est ouvert *)
 Application.HelpCommand(Help_Quit,0);
end;

(***********************************************************************)
(********************** Changements de dimensions **********************)
(***********************************************************************)

procedure TForm1.FormResize(Sender: TObject);
(* changements de dimensions *)
begin
 SetSize;
end;

procedure TForm1.SetSize;
const TbHeight=18;   (* hauteur des onglets *)
var Memo:TMemoFig;
    R:TRect;
begin
 { onglets }
 R.Left:=0; R.Top:=ClientHeight-TbHeight;
 R.Right:=R.Left+round((ClientWidth/100)*CurSplit);
 R.Bottom:=R.Top+Tbheight;
 TabSet1.BoundsRect:=R;
 { notebook }
 R.Top:=PanelBoutons.Height;
 R.Bottom:=ClientHeight-TbHeight;
 NoteBook1.BoundsRect:=R;
 { splitpanel }
 R.Left:=Notebook1.width;
 R.Right:=R.Left+SplitPanel.width;
 R.bottom:=ClientHeight;
 SplitPanel.BoundsRect:=R;
 { paintbox }
 R.Top:=PanelBoutons.Height;
 R.Left:=Notebook1.Width+SplitPanel.Width;
 R.Right:=R.Left+ClientWidth-Notebook1.Width-SplitPanel.Width;
 R.Bottom:=R.Top+ClientHeight-PanelBoutons.Height;
 PaintBox1.BoundsRect:=R;
 { imageo }
 Memo:=MemoCourant;
 if Memo<>nil then
  Memo.TailleFigure(Paintbox1.Width,Paintbox1.Height);
end;

(************************************************************************)
(*********************** Dessin de la figure ****************************)
(************************************************************************)

procedure TForm1.PaintBox1Paint(Sender: TObject);
var memo:TMemoFig;
    NewRect:TRect;
begin
 Memo:=MemoCourant;
 if Memo<>nil then
  (* on ne recompile pas pour garder les positions *)
  Memo.DessineFigure(Paintbox1.Canvas)
 else
  begin
   NewRect:=Rect(0, 0, Paintbox1.Width, Paintbox1.Height);
   PaintBox1.Canvas.FillRect(NewRect);
  end;
end;

(*********************************************************************)
(************* Transformation de la figure  la souris ***************)
(*********************************************************************)

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var memo:TMemoFig;
begin
if not (Shift=[ssLeft]) then exit;
memo:=MemoCourant;
if memo=nil then exit;
if MonPoint<>'' then
 DeselectionPoint(memo.hFigure,paintbox1.canvas.handle);
MonPoint:=SelectionPoint(memo.hFigure,x,y,paintbox1.canvas.handle);
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var memo:TMemoFig;
begin
 if MonPoint<>'' then
  begin
   memo:=MemoCourant;
   if memo<>nil then
    DeselectionPoint(memo.hFigure,paintbox1.canvas.handle);
   MonPoint:=''
  end;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var memo:TMemoFig;
begin
 if MonPoint<>'' then
  begin
   memo:=MemoCourant;
   if memo<>nil then
    begin
     MoveSelect(memo.hFigure,x,y);
     DessineParBitmap;
    end;
  end;
end;

(***********************************************************************)
(**************** Dplacements de la barre de sparation ***************)
(***********************************************************************)

procedure TForm1.SplitPanelMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Splitting:=true;  (* on a appuy sur le bouton *)
end;

procedure TForm1.SplitPanelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Splitting then
 begin  (* on a relach le bouton *)
  Splitting:=false;
  (* enregistrer la position *)
  CurSplit:=round(100.0*SplitPanel.Left/ClientWidth);
  if CurSplit>80 then CurSplit:=60;
  (* mettre l'affichage  jour *)
  SetSize;
 end;
end;

procedure TForm1.SplitPanelMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
if Splitting then  (* on dplace la barre de sparation *)
 begin
  SplitPanel.Left:=SplitPanel.Left+X;
 end;
end;

(**********************************************************************)
(********************** Changements de Pages **************************)
(**********************************************************************)

procedure TForm1.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
(* changement de page courante pour les onglets *)
begin
 NoteBook1.PageIndex:=NewTab;
end;

procedure TForm1.Notebook1PageChanged(Sender: TObject);
(* changement de page courante pour le multi-page *)
var page:TPage;
    memo:TMemoFig;
begin
page:=PageCourante;
if page<>nil then
 if page.controlcount>0 then
  begin
   (* il y a un nouveau mmo actif, on construit la figure *)
   memo:=MemoCourant;
   if Memo<>nil then
    begin
     memo.Font.Name:=Inirec.MemoFontName;
     memo.Font.Size:=Inirec.MemoFontSize;
     memo.TailleFigure(Paintbox1.Width,Paintbox1.Height);
     memo.DessineFigure(Paintbox1.Canvas);
    end;
  end;
end;

(**********************************************************************)
(*************************** Menu Fichier *****************************)
(**********************************************************************)

procedure TForm1.Nouveau1Click(Sender: TObject);
(* cration d'un nouveau fichier vide *)
var page : TPage;
    memo : TMemoFig;
begin
 (* une page de plus *)
 notebook1.Pages.Add('');
 notebook1.PageIndex := notebook1.Pages.Count - 1;
 tabset1.Tabs.Add(NomNouvellePage);
 tabset1.TabIndex := notebook1.PageIndex;
 page:=PageCourante;
 if page<>nil then
  begin
   FaireMemo('',page);
   page.Visible := true;
   Memo:=MemoCourant;
   Memo.SetFocus;
   Memo.TailleFigure(Paintbox1.Width,Paintbox1.Height);
   Memo.DessineFigure(Paintbox1.Canvas);
  end;
end;

procedure TForm1.Quitter1Click(Sender: TObject);
(* quitter l'application *)
begin
 close;
end;

procedure TForm1.Fermer1Click(Sender: TObject);
(* fermer le fichier actif *)
var temp,rep : integer;
    memo : TMemoFig;
    page : TPage;
begin
 if NoteBook1.Pages.Count<1 then exit;
 memo:=MemoCourant;
 if memo=nil then exit;
 if memo.Modified then
  begin
   rep:=Application.Messagebox('Faut-il enregistrer les modifications ?',
                             'Confimer',Mb_YesNoCancel);
   if rep=idYes then
    Sauver1Click(nil)
   else if rep=idCancel then exit;
  end;
 temp:=NumPageCourante;
 if temp>=0 then
  begin
   NoteBook1.Pages.Delete(temp);
   Tabset1.Tabs.Delete(temp);
   if temp=Notebook1.Pages.Count then dec(temp);
   Tabset1.TabIndex:=temp;
   notebook1.PageIndex:=temp;
   page:=PageCourante;
   if page<>nil then page.Show;
   memo:=MemoCourant;
   if Memo<>nil then Memo.TailleFigure(Paintbox1.Width,Paintbox1.Height);
   PaintBox1.Repaint;
  end;
end;

procedure TForm1.Ouvrir1Click(Sender: TObject);
(* ouvrir un fichier *)
var ro : Boolean;
begin
if OpenDialog1.Execute then
 begin
  ro:= (ofReadOnly in OpenDialog1.Options);
  OuvreFichier(OpenDialog1.FileName,ro);
 end;
end;

procedure TForm1.Sauversous1Click(Sender: TObject);
(* sauver avec nom de fichier *)
begin
 if NoteBook1.pages.count<1 then exit;
 if SaveDialog1.Execute then
  SaveMemo(SaveDialog1.FileName);
end;

procedure TForm1.Sauver1Click(Sender: TObject);
(* sauver avec le nom courant s'il existe *)
begin
 if NoteBook1.Pages.Count<1 then exit;
 if NomFichierCourant='' then
  SauverSous1Click(Sender)
 else SaveMemo(NomFichierCourant);
end;


(**********************************************************************)
(************************** Menu Edition ******************************)
(**********************************************************************)

procedure TForm1.Copier1Click(Sender: TObject);
(* copier texte dans Presse-Papiers *)
var memo:TMemoFig;
begin
 memo:=MemoCourant;
 if memo<>nil then memo.CopyToClipBoard;
end;

procedure TForm1.Couper1Click(Sender: TObject);
(* couper texte dans Presse-Papiers *)
var memo:TMemoFig;
begin
 memo:=MemoCourant;
 if memo<>nil then memo.CutToClipBoard;
end;

procedure TForm1.Coller1Click(Sender: TObject);
(* coller  partir du Presse-Papiers *)
var memo:TMemoFig;
begin
 memo:=MemoCourant;
 if memo<>nil then memo.PasteFromClipBoard;
end;

procedure TForm1.Voirsource1Click(Sender: TObject);
(* affichage du script *)
begin
 CurSplit:=50;
 SetSize;
end;

procedure TForm1.Options1Click(Sender: TObject);
(* choix des options *)
var n,err:Integer;
    memo:TMemo;
begin
 with OptionsDialog, Inirec do
  begin
   EditImpUnit.Text:=IntToStr(ImpUnit);
   if ImpressionCouleur then
    CheckBox1.Checked:=true
   else CheckBox1.Checked:=false;
   Combobox1.Text:=MemoFontName;
   EditFontSize.Text:=IntToStr(MemoFontSize);
   if OptionsDialog.ShowModal=id_ok then
    begin
     if ComboBox1.Text<>'' then
      MemoFontName:=Combobox1.Text;
     val(EditFontSize.Text,n,err);
     if err=0 then MemoFontSize:=n;
     Memo:=MemoCourant;
     if Memo<>nil then
      begin
       Memo.Font.Name:=MemoFontName;
       Memo.Font.Size:=MemoFontSize;
      end;
     val(EditImpUnit.Text,n,err);
     if err=0 then Impunit:=n;
     ImpressionCouleur:=CheckBox1.Checked;
    end;
  end;
end;

(***********************************************************************)
(**************************** Menu Dessin ******************************)
(***********************************************************************)

procedure TForm1.Dessiner1Click(Sender: TObject);
(* redessiner la figure du script : cela annule les changements *)
var Memo:TMemoFig;
begin
 memo:=MemoCourant;
 if memo<>nil then
  begin
   (* recompiler *)
   memo.FaireFigure;
   (* dessiner *)
   memo.DessineFigure(Paintbox1.Canvas);
  end;
end;

procedure TForm1.Sauversous2Click(Sender: TObject);
(* sauver le script avec les positions des points *)
var memo:TMemoFig;
begin
 if NoteBook1.Pages.Count<1 then exit;
 if SaveDialog1.Execute then
  begin
   memo:=MemoCourant;
   if memo<>nil then SauverFig(memo.hFigure,SaveDialog1.FileName);
  end;
end;

procedure TForm1.Zoom1Click(Sender: TObject);
(* zoom + : agrandissement *)
var memo:TMemoFig;
    oldu:Real;
begin
 if NoteBook1.Pages.Count<1 then exit;
 memo:=MemoCourant;
 oldu:=GetUnit(memo.hFigure);
 Echelle(memo.hFigure,oldu*1.1);
 memo.DessineFigure(Paintbox1.Canvas);
end;

procedure TForm1.Zoom2Click(Sender: TObject);
(* zoom - : rduction *)
var memo:TMemoFig;
    oldu:Real;
begin
 if NoteBook1.Pages.Count<1 then exit;
 memo:=MemoCourant;
 oldu:=GetUnit(memo.hFigure);
 Echelle(memo.hFigure,oldu/1.1);
 memo.DessineFigure(Paintbox1.Canvas);
end;

procedure TForm1.SauverBMP1Click(Sender: TObject);
(* enregistrer sous forme de Bitmap *)
var bitmap:TBitMap;
    memo:TMemoFig;
begin
if NoteBook1.Pages.Count<1 then exit;
with Savedialog1 do
 begin
  DefaultExt:='bmp';
  FilterIndex:=2;
  if Execute then
   begin
    try
     memo:=MemoCourant;
     bitmap:=TBitMap.Create;
     bitmap.Width:=Paintbox1.Width;
     bitmap.height:=Paintbox1.Height;
     if memo<>nil then memo.DessineFigure(bitmap.Canvas);
     bitmap.Savetofile(FileName);
    finally
     bitmap.free;
    end;
   end;
  DefaultExt:='fig';
  FilterIndex:=1;
 end;
end;

procedure TForm1.CopierBMP1Click(Sender: TObject);
var bitmap:TBitMap;
    memo:TMemoFig;
begin
 if NoteBook1.Pages.Count<1 then exit;
 try
  memo:=MemoCourant;
  bitmap:=TBitMap.Create;
  if memo<>nil then
   begin
    if not IniRec.ImpressionCouleur then
     begin  (* copie monochrome *)
      bitmap.MonoChrome:=true;
      ModeNoirEtBlanc(memo.hFigure);
     end;
    bitmap.Width:=PaintBox1.Width;
    bitmap.Height:=PaintBox1.Height;
    Memo.DessineFigure(bitmap.Canvas);
    ClipBoard.Assign(bitmap);
    ModeCouleur(memo.hFigure);
   end;
 finally
  bitmap.Free;
 end;
end;

procedure TForm1.Imprimer1Click(Sender: TObject);
(* imprimer la figure *)
var oldu,newu:Real;
    ofs:Integer;
    limpmm:Integer;
    memo:TMemoFig;
begin
 memo:=MemoCourant;
 if memo=nil then exit;
 if PrintDialog1.Execute then
  begin
   try
    Printer.BeginDoc;
    (* changement d'units *)
    oldu:=GetUnit(memo.hFigure);
    ofs:=GetFontSize(memo.hFigure);
    if Inirec.ImpUnit=0 then
     begin  (* on adapte  la largeur de la page *)
      newu:=(oldu/paintbox1.width)*Printer.PageWidth;
     end
    else
     begin   (* on utilise l'unit choisie *)
      limpmm:=GetDeviceCaps(Printer.Canvas.Handle,HorzSize);
      newu:=Inirec.ImpUnit;
      newu:=newu*Printer.PageWidth/limpmm;
     end;
    memo.TailleFigure(Printer.PageWidth,
           round((paintbox1.height/paintbox1.width)*Printer.PageWidth));
    Echelle(memo.hFigure,newu);
    SetFontSize(memo.hFigure,0);
    if not IniRec.ImpressionCouleur then
      ModeNoirEtBlanc(memo.hFigure);
    LieuCroix(memo.hFigure);
    SetPenWidth(memo.hFigure,4);
    memo.DessineFigure(Printer.Canvas);
    Printer.EndDoc;
   finally
    (* on rtablit les paramtres *)
    Echelle(memo.hFigure,oldu);
    SetFontSize(memo.hFigure,ofs);
    Memo.TailleFigure(Paintbox1.Width,Paintbox1.Height);
    if not IniRec.ImpressionCouleur then
     ModeCouleur(memo.hFigure);
    SetPenWidth(memo.hFigure,1);
    LieuPoints(memo.hFigure);
   end;
 end;
end;

(***********************************************************************)
(**************************** Menu Aide ********************************)
(***********************************************************************)

procedure TForm1.Indexdelaide1Click(Sender: TObject);
(* index de l'aide *)
begin
 Application.HelpJump('Main_Index');
end;

procedure TForm1.Apropos1Click(Sender: TObject);
(* bote A propops... *)
begin
 AboutBox:=TAboutBox.Create(self);
 AboutBox.ShowModal;
 AboutBox.Free;
end;

procedure TForm1.AideImageoClick(Sender: TObject);
(* langage imageo *)
begin
 Application.HelpFile:='Imageo.hlp';
 Application.HelpJump('Main_Index');
 Application.HelpFile:='WImageo.hlp';
end;

procedure TForm1.Aidesurunmotcl1Click(Sender: TObject);
(* aide sur mot en cours d'dition *)
var Memo:TMemo;
    S : String;
begin
 Memo:=MemoCourant;
 if memo=nil then exit;
 if Memo.SelLength<>0 then
  S:=Memo.SelText
 else S:=MemoCourant.MotCourant;
 (* nettoyer les espaces aux extrmits *)
 if S<>'' then
  while (length(s)>0) and (s[1]=' ') do
   delete(s,1,1);
 if S<>'' then
  while (length(s)>0) and (s[length(s)]=' ') do
   delete(s,length(s),1);
  (* lancer la recherche du mot cl *)
 S:=S+#0;
 Application.HelpFile:='imageo.hlp';
 Application.HelpCommand(Help_Key,longint(@s[1]));
 Application.HelpFile:='wimageo.hlp';
end;

(************************************************************************)
(************************* Messages Windows *****************************)
(************************************************************************)

procedure TForm1.WMERASEBKGND(var Msg:TMessage);
{ empche le fond de la fentre de se redessiner }
{ vite le clignotement de la figure }
begin
 Msg.Result:=1;
end;

procedure TForm1.WMDROPFILES(var Msg:TMEssage);
(* gestion drag and drop *)
var
 Nom : String;
 i,n,len : Integer;
begin
 N:=DragQueryFile(Msg.WParam,$FFFF,nil,0); (*API*)
 for i:=0 to n-1 do
  begin
   len:=DragQueryFile(Msg.WParam,i,nil,0);
   DragQueryFile(Msg.WParam,i,@Nom[1],len+1);
   Nom[0]:=chr(len);
   OuvreFichier(Nom,false);
  end;
 DragFinish(Msg.WParam);
 {SetWindowPos(Self.Handle,HWND_TopMost,0,0,0,0,swp_nomove or swp_nosize);}
end;

(***********************************************************************)
(*********************** Mthodes ajoutes *****************************)
(***********************************************************************)

function TForm1.NumPageCourante:Integer;
(* numro du mmo courant *)
begin
 if NoteBook1.Pages.Count>0 then
  result:=NoteBook1.PageIndex
 else result:=-1;
end;

function TForm1.NomFichierCourant:String;
(* nom complet du fichier du mmo courant *)
var n:Integer;
begin
 n:=NumPageCourante;
 if n>=0 then
  Result:=NoteBook1.Pages[n]
 else Result:='';
end;

function TForm1.FaireMemo(NomFichier:String; page:TPage):Boolean;
(* cre le mmo d'une page, mmo vide si NomFichier='' *)
var Memo:TMemoFig;
begin
 Result:=true;
 memo := TMemoFig.Create(page);
 memo.Parent:=page;
 memo.PopupMenu:=MemoPopupmenu;
 memo.HelpContext:=100;
 if NomFichier<>'' then
   if not Memo.Ouvrir(NomFichier) then
    begin
     ShowMessage('Ouverture du fichier impossible.');
     memo.clear;
     Result:=false;
    end;
end;

function TForm1.MemoCourant:TMemoFig;
var page:TPage;
begin
 page:=PageCourante;
 if page=nil then
  Result:=nil
 else
  Result:=TMemoFig(page.controls[0]);
end;

function TForm1.PageCourante:TPage;
var n:Integer;
begin
 n:=NumPageCourante;
 if n<0 then
  Result:=nil
 else
  Result:=TPage(notebook1.Pages.Objects[n]);
end;

procedure TForm1.SaveMemo(NomFichier:String);
(* sauvegarde du mmo *)
var memo : TMemoFig;
begin
 memo:=MemoCourant;
 if memo.Sauver(NomFichier) then
  begin
   memo.Modified:=false;
   TabSet1.Tabs[NumPageCourante]:=OnlyFileName(NomFichier);
   NoteBook1.Pages[NumPageCourante]:=NomFichier;
  end
 else Application.MessageBox('Sauvegarde impossible.','Erreur',Mb_Ok);
end;

procedure TForm1.DessineParBitmap;
(* dessine la figure dans un bitmap avant de l'envoyer  la PaintBox *)
(* mthode utilise lors des dplacements de la figure *)
var bitmap:TBitmap;
    memo:TMemoFig;
    R:TRect;
begin
 if NoteBook1.Pages.Count<1 then exit;
 try
  R.Top:=0; R.Left:=0;
  R.Bottom:=paintbox1.height;
  R.Right:=paintbox1.width;
  bitmap:=TBitmap.Create;
  bitmap.width:=paintbox1.width;
  bitmap.height:=paintbox1.height;
  memo:=MemoCourant;
  memo.DessineFigure(bitmap.canvas);
  PaintBox1.Canvas.CopyRect(R,Bitmap.Canvas,R);
 finally
  bitmap.free;
 end;
end;

procedure TForm1.OuvreFichier(Nom:String; ro:Boolean);
(* ouvrir un fichier *)
var page : TPage;
    memo : TMemoFig;
    n : Integer;
begin
 memo:=MemoCourant;
 n:=NumPageCourante;
 if (n>=0) and (NomFichierCourant='') and (memo<>nil)
   and (not memo.Modified) then
  begin
   NoteBook1.Pages[n]:=Nom;
   Tabset1.Tabs[n]:=OnlyFileName(Nom);
   memo.Free;
  end
 else
  begin
   NoteBook1.Pages.Add(Nom);
   n:=NoteBook1.Pages.Count-1;
   TabSet1.Tabs.Add(OnlyFileName(Nom));
  end;
 Notebook1.PageIndex:=n;
 TabSet1.TabIndex:=n;
 page:=PageCourante;
 if page<>nil then
  begin
   if not FaireMemo(Nom,page) then
    begin
     n:=NumPageCourante;
     NoteBook1.Pages[n]:='';
     TabSet1.Tabs[n]:=NomNouvellePage;
    end
   else if ro then memo.ReadOnly:=true;
   page.Visible := true;
   memo:=MemoCourant;
   memo.SetFocus;
   memo.TailleFigure(Paintbox1.Width,Paintbox1.Height);
   memo.DessineFigure(Paintbox1.Canvas);
  end;
end;

end.

