unit Utils;
{ options et lecture/criture du fichier ini }
{ K.B. 1999 }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, IniFiles;

type
 TInirec = record
  Haut, Gauche, Largeur, Hauteur : Integer;
  MemoFontName : String[40];
  MemoFontSize : Integer;
  ImpUnit : Integer;
  ImpressionCouleur : Boolean;
  end;

var
 IniRec : TIniRec;

const
 NbPages:Integer = 0;

(* gestion des fichiers ini *)
procedure ReadIniFile;
procedure WriteIniFile;
function IniFileName:String;

(* utilitaires *)
function OnlyFileName(S:String):String;
function NomNouvellePage:String;
function MajChar(c:Char):Char;

implementation

function MajChar(c:Char):Char;
begin
 case c of
  'a','': MajChar:='A';
  'e','','','','' : MajChar:='E';
  'i','','' : MajChar:='I';
  'o','','': MajChar:='O';
  'u','','','': MajChar:='U';
  '': MajChar:='C';
  else MajChar:=upcase(c);
 end;
end;

function NomNouvellePage:String;
begin
 inc(NbPages);
 Result:='Feuille '+IntToStr(NbPages);
end;

function OnlyFileName(S:String):String;
var i:Integer;
    tmp:String;
begin
 tmp:=ExtractFileName(S);
 i:=pos('.',tmp);
 if i<>0 then tmp:=copy(tmp,1,i-1);
 tmp:=lowercase(tmp);
 Result:=tmp;
end;

procedure ReadIniFile;
var IniFile:TIniFile;
    S:String;
    n:Integer;
begin
 S:=IniFileName;
 try
  IniFile:=TIniFile.Create(S);
  with IniFile,IniRec do
   begin
    MemoFontName:=ReadString('TEXTE','fonte','Times New Roman');
    MemoFontSize:=ReadInteger('TEXTE','taille',8);
    Gauche:=ReadInteger('POSITION', 'gauche',20);
    Haut:=ReadInteger('POSITION','haut',20);
    Largeur:=ReadInteger('POSITION','largeur',600);
    Hauteur:=ReadInteger('POSITION','hauteur',400);
    n:=ReadInteger('IMPRESSION','couleur',0);
    if n=0 then
     ImpressionCouleur:=false
    else ImpressionCouleur:=true;
    ImpUnit:=ReadInteger('IMPRESSION','unit',5);
   end;
 finally
  IniFile.Free;
 end;
end;

procedure WriteIniFile;
var IniFile:TIniFile;
    S:String;
    n:Integer;
begin
 S:=IniFileName;
 try
  IniFile:=TIniFile.Create(S);
  with IniFile,Inirec do
   begin
    WriteInteger('POSITION', 'gauche',gauche);
    WriteInteger('POSITION','haut',haut);
    WriteInteger('POSITION','largeur',largeur);
    WriteInteger('POSITION','hauteur',hauteur);
    if ImpressionCouleur then
     n:=1
    else n:=0;
    WriteInteger('IMPRESSION','couleur',n);
    WriteInteger('IMPRESSION','unit',ImpUnit);
    WriteString('TEXTE','fonte',MemoFontName);
    WriteInteger('TEXTE','taille',MemoFontSize);
   end;
 finally
  IniFile.Free;
 end;
end;

function IniFileName:String;
var S:String;
begin
 S:=Application.ExeName;
 S:=ChangeFileExt(S,'.ini');
 Result:=S;
end;

end.
