unit OMemo;
{ mmo contenant un script Imageo }
{ K.B. mai 1998 }

interface

uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,
  ClipBrd, Printers, ShellApi, UImageo, Utils;

type
 TMemoFig=class(TMemo)

 constructor Create(AOwner: TComponent); override;
 destructor Destroy; override;
 public
 hFigure : TFigHandle;
 function Ouvrir(NomFichier:String):Boolean;
 function Sauver(NomFichier:String):Boolean;
 procedure FaireFigure;
 procedure DessineFigure(canvas:TCanvas);
 procedure TailleFigure(w,h:Integer);
 function MotCourant:String;
 end;

implementation

{ objet TMemoFig }

constructor TMemoFig.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 font.name:=Inirec.MemoFontName;
 font.size:=Inirec.MemoFontSize;
 Color:=clWindow;
 BorderStyle:=bsnone;
 ScrollBars:=ssVertical;
 Align:=alClient;
 Wordwrap:=false;
 HelpContext:=100;
 hFigure:=CreateFig(10,10);
 SetMacroPath(hFigure,
  ExtractFilePath(Application.ExeName)+'\imageo.mac');
 SetFontName(hFigure,font.name);
end;

destructor TMemoFig.Destroy;
begin
 destroyfig(hFigure);
 inherited Destroy;
end;

procedure TMemoFig.TailleFigure(w,h:Integer);
begin
 SetDim(hFigure,w,h);
end;

function TMemoFig.Ouvrir(NomFichier:String):Boolean;
var f:TextFile;
    S:String;
begin
 Result:=true;
 assignfile(f,Nomfichier);
 {$I-}
 reset(f);
 {$I+}
 if IOResult<>0 then
  begin
   Result:=false;
   exit;
  end;
 clear;
 while not eof(f) do
  begin
   readln(f,S);
   OemToAnsiBuff(@S[1],@S[1],Byte(S[0]));
   lines.add(S);
  end;
 close(f);
 Modified:=false;
 {SelStart:=0;}
 FaireFigure;
end;

function TMemoFig.Sauver(NomFichier:String):Boolean;
var f:TextFile;
    i:Integer;
    S:String;
begin
 Result:=true;
 assignfile(f,NomFichier);
 {$I-}
 rewrite(f);
 {$I+}
 if IOResult<>0 then
  begin
   Result:=false;
   exit;
  end;
 for i:=0 to lines.count-1 do
  begin
   S:=lines[i];
   AnsiToOEMBuff(@S[1],@S[1],Byte(S[0]));
   writeln(f,S);
  end;
 close(f);
 Modified:=false;
end;

procedure TMemoFig.FaireFigure;
var i : Integer;
begin
 resetfig(hFigure);
 if Lines.count>0 then
  for i:=0 to Lines.Count-1 do
   ExecStr(hFigure,Lines[i]);
end;

procedure TMemoFig.DessineFigure(canvas:TCanvas);
begin
 DrawFig(hFigure,canvas.handle);
end;

function TMemoFig.MotCourant:String;
var S : string;
    SStart, SLen : integer;
begin
 (*memorisation*)
 SStart:=SelStart;
 SLen:=SelLength;
 (*dgager le mot du texte*)
 (*balayage  droite*)
 repeat
  if SelStart>0 then
   begin
    selStart:=selStart-1;
    selLength:=selLength+1;
    s:=SelText;
   end;
 until (SelStart=0) or not(MajChar(S[1]) in ['A'..'Z']);
 if not(MajChar(s[1]) in ['A'..'Z']) then
  begin
   {delete(s,1,1);}
   SelStart:=SelStart+1;
  end;
 (*balayage  gauche*)
 repeat
  selLength:=selLength+1;
  s:=SelText;
 until (SelStart+SelLength>=GetTextLen)
  or not(MajChar(s[length(s)]) in ['A'..'Z']);
 if not(MajChar(s[length(s)]) in ['A'..'Z']) then
  delete(s,length(s),1);
 (*restauration*)
 SelStart:=SStart;
 SelLength:=SLen;
 (*recherche*)
 Result:=s;
end;

end.

