unit Uimageo;
{ interface  la DLL Imageo }
{ K.B. fvrier 1998 }

interface
uses Wintypes;

Const

 { identificateurs de types }
 idPointMobile=1;
 idPointConstruit=2;
 idCercle=4;
 idDroite=8;
 idSegment=16;
 idDemiDroite=32;
 idTexte=64;
 idPoint=idPointMobile+idPointConstruit;
 idLigne=idSegment+idCercle+idDroite+idDemiDroite;
 idGen=idPoint+idLigne;

 { statut des objets }
 stInitOk  = 1;   { initialisation russie }
 stCalcOk  = 2;   { calcul des donnes russi }
 stOk      = 3;   { objet valide }
 stVisible = 4;   { doit tre affich }
 stChoisi  = 8;   { est slectionn }
 stMobile  = 16;  { peut tre dplac }
 stTrace   = 32;  { doit laisser une trace }

Type
 TFigHandle=Integer;
 { type destin  recevoir un handle sur une figure }

TInfoRec=record
 { type destin  recevoir les infos sur un objet }
 Name : String[8];
 Typ  : word;
 Stat : word;
 x1,y1 : Real;
 x2,y2 : Real;
 end;

function CreateFig(largeur,hauteur:Integer):TFigHandle;
{Cette fonction fournit un handle  passer en paramtre dans les
autres procdures et fonctions, elle doit donc tre appele avant
toutes les autres.}

procedure DestroyFig(var hfig:TFigHandle);
{Libration de la mmoire utilise par la figure; hfig est mis  0.}

function ExecStr(hfig:TFigHandle; S:String):Boolean;
{Excute l'instruction S; renvoie true si pas d'erreur.}

procedure DrawFig(hfig:TFigHandle; ADC:HDC);
{Dessine la figure dans le device-context fourni par hDC; c'est
le programme appelant qui se charge de la gestion de ce device-
context.}

function SelectionPoint(hfig:TFigHandle; x,y:Integer; ADC:HDC):String;
{Slectionne le point correspondant  (x,y); renvoie true si un
point a t effectivement trouv, le point est alors redessin dans
le device-context fourni.}

procedure DeselectionPoint(hfig:TFigHandle; ADC:HDC);
{Dslectionne le point slectionn s'il existe, celui-ci est alors
redessin dans le device-context fourni.}

procedure MoveSelect(hfig:TFigHandle;x,y:Integer);
{Dplace le point slectionn en (x,y); la figure n'est pas redessine.}

function GetInfo(hfig:TFigHandle; Nom:String; var Inf:TInfoRec):Boolean;
{Fournit les informations sur l'objet nomm NOM dans la structure
Inf; renvoie false si aucun objet n'a t trouv.}

procedure SetDim(hfig:TFigHandle; largeur,hauteur:Integer);
{Changement les dimensions en pixels de la figure; la figure n'est pas
redessine.}

procedure Echelle(hfig:TFigHandle; u:Real);
{Dfinit l'unit en pixels; la figure n'est pas redessine.}

procedure ChargeFichier(hfig:TFigHandle; Nom:String);
{ Interprte le fichier Nom }

procedure ResetFig(hfig:TFigHandle);
{ vide la figure de son contenu }

function GetUnit(hfig:TFigHandle):Real;
{ renvoie le nombre de pixels par unit }

function SauverFig(hFig:TFigHandle; NomFichier:String):Boolean;
{ crit le script correspondant  la figure dans un fichier }

procedure SetMacroPath(hfig:TFigHandle; Chemin:String);
{ dfinit le nom du fichier de Macros }

procedure SetPenWidth(hfig:TFigHandle; t:Integer);
{ dfinit la largeur du crayon pour le trac des lignes
  valeur 1 par dfaut }

procedure ModeCouleur(hfig:TFigHandle);
{ rtablit l'affichage des couleurs dfinies dans
  le script }

procedure ModeNoirEtBlanc(hfig:TFigHandle);
{ provoque un affichage en noir sur fond blanc }

procedure LieuPoints(hfig:TFigHandle);
{ affiche les lieux de points avec des points }

procedure LieuCroix(hfig:TFigHandle);
{ affiche les lieux de points avec des croix }

procedure SetFontSize(hfig:TFigHandle; t:Integer);
{ fixe la hauteur des caractres en units logiques }

function GetFontSize(hfig:TFigHandle):Integer;
{ renvoie la hauteur des caractres }

procedure SetFontName(hfig:TFigHandle; S:String);
{ fixe le nom de la fonte utilise }

function GetFontName(hfig:TFigHandle):String;
{ renvoie le nom de la fonte utilise }

implementation

function CreateFig(largeur,hauteur:Integer):TFigHandle;
 external 'IMAGEO' index 1;
procedure DestroyFig(var hfig:TFigHandle);
 external 'IMAGEO' index 2;
function ExecStr(hfig:TFigHandle; S:String):Boolean;
 external 'IMAGEO' index 3;
procedure DrawFig(hfig:TFigHandle; ADC:HDC);
 external 'IMAGEO' index 4;
function SelectionPoint(hfig:TFigHandle; x,y:Integer; ADC:HDC):String;
 external 'IMAGEO' index 5;
procedure DeselectionPoint(hfig:TFigHandle; ADC:HDC);
 external 'IMAGEO' index 6;
procedure MoveSelect(hfig:TFigHandle;x,y:Integer);
 external 'IMAGEO' index 7;
function GetInfo(hfig:TFigHandle; Nom:String; var Inf:TInfoRec):Boolean;
 external 'IMAGEO' index 8;
procedure SetDim(hfig:TFigHandle; largeur,hauteur:Integer);
 external 'IMAGEO' index 9;
procedure Echelle(hfig:TFigHandle; u:Real);
 external 'IMAGEO' index 10;
procedure ChargeFichier(hfig:TFigHandle; Nom:String);
 external 'IMAGEO' index 11;
procedure ResetFig(hfig:TFigHandle);
 external 'IMAGEO' index 12;
function GetUnit(hfig:TFigHandle):Real;
 external 'IMAGEO' index 13;
function SauverFig(hFig:TFigHandle; NomFichier:String):Boolean;
 external 'IMAGEO' index 14;
procedure SetMacroPath(hfig:TFigHandle; Chemin:String);
 external 'IMAGEO' index 15;
procedure SetPenWidth(hfig:TFigHandle; t:Integer);
 external 'IMAGEO' index 16;
procedure ModeCouleur(hfig:TFigHandle);
 external 'IMAGEO' index 17;
procedure ModeNoirEtBlanc(hfig:TFigHandle);
 external 'IMAGEO' index 18;
procedure LieuPoints(hfig:TFigHandle);
 external 'IMAGEO' index 19;
procedure LieuCroix(hfig:TFigHandle);
 external 'IMAGEO' index 20;
procedure SetFontSize(hfig:TFigHandle; t:Integer);
 external 'IMAGEO' index 21;
function GetFontSize(hfig:TFigHandle):Integer;
 external 'IMAGEO' index 22;
procedure SetFontName(hfig:TFigHandle; S:String);
 external 'IMAGEO' index 23;
function GetFontName(hfig:TFigHandle):String;
 external 'IMAGEO' index 24;
end.

